#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include "obfuscator.h"

static char key[] = {0x05, 0x0c, 0xee, 0x80, 0xbe, 0xbd, 0xb2, 0x84, 0x61, 0x5d, 0x5b, 0x1d, 0xda, 0xea, 0x23, 0xbb,
                    0x65, 0x07, 0x39, 0x14, 0x92, 0x2a, 0x6d, 0x21, 0x1a, 0x46, 0x77, 0x39, 0xf5, 0xd1, 0x47, 0x8c,
                    0x10, 0xc0, 0x80, 0x3b, 0x6f, 0x96, 0x48, 0x3c, 0xd3, 0xb4, 0xe9, 0x25, 0x71, 0xd3, 0x81, 0x72,
                    0xa8, 0xe7, 0x63, 0xa0, 0xb9, 0x6b, 0x7e, 0x87, 0x30, 0xff, 0x0b, 0xcf, 0x5f, 0xf7, 0x1b, 0xb7};

char *deobfuscate(char *buffer, int len) {
	int key_len = sizeof(key);

	char *ret = malloc(sizeof(char) * (len + 1));
	for (int i = 0; i < len; i++) {
		ret[i] = buffer[i] ^ key[i % key_len];
	}
	ret[len] = '\0';
	return ret;
}

// Remember to free pointer after use
char *protect(char *s) {
	char *ret = malloc(sizeof(char) * (strlen(s) + 1));
	if (ret == NULL) return NULL;
	strcpy(ret, s);
	return ret;
}